Bug 1366713 - Review Request: nunit2 - unit-testing framework for .Net/mono
Summary: Review Request: nunit2 - unit-testing framework for .Net/mono
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Claudio Rodrigo Pereyra DIaz
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1354599 maxmind-db
TreeView+ depends on / blocked
 
Reported: 2016-08-12 15:50 UTC by Timotheus Pokorra
Modified: 2016-11-13 15:20 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-11-13 15:20:10 UTC
claudiorodrigo: fedora-review+


Attachments (Terms of Use)

Description Timotheus Pokorra 2016-08-12 15:50:19 UTC
Spec URL: https://tpokorra.fedorapeople.org/nunit2/nunit2.spec
SRPM URL: https://tpokorra.fedorapeople.org/nunit2/nunit2-2.6.4-13.fc26.src.rpm

Description: NUnit is a Unit-testing Framework for .Net/Mono.
We already have a package nunit. I have upgraded that package to Version 3, which breaks at least one package, nant. This package nunit2 should solve those issues by providing NUnit2.

There is not much a difference in the spec file from the nunit package which is in f24 and f25 branch, I just modified the paths and filenames so that nunit and nunit2 can be installed in parallel.

Comment 1 gil cattaneo 2016-08-15 21:42:38 UTC
Please, use  "install -p" ..., and remove all useless Group field
and if possible replace %{__mkdir_p} with "mkdir -p"

Comment 2 Timotheus Pokorra 2016-08-16 07:48:53 UTC
Thanks Gil for those suggestions!
I have adjusted the spec file and the src.rpm accordingly:

Spec URL: https://tpokorra.fedorapeople.org/nunit2/nunit2.spec
SRPM URL: https://tpokorra.fedorapeople.org/nunit2/nunit2-2.6.4-13.fc26.src.rpm

Comment 3 gil cattaneo 2016-08-16 18:16:04 UTC
(In reply to Timotheus Pokorra from comment #2)
> Thanks Gil for those suggestions!
> I have adjusted the spec file and the src.rpm accordingly:
> 
> Spec URL: https://tpokorra.fedorapeople.org/nunit2/nunit2.spec
> SRPM URL:
> https://tpokorra.fedorapeople.org/nunit2/nunit2-2.6.4-13.fc26.src.rpm

have missing:
find %{_builddir}/%{?buildsubdir}/bin -name \*.dll -exec install -p \-m0755 "{}" "%{buildroot}%{_monodir}/nunit2/" \;
find %{_builddir}/%{?buildsubdir}/bin -name \*.exe -exec install -p \-m0755 "{}" "%{buildroot}%{_monodir}/nunit2/" \;
for i in nunit-console-runner.dll nunit.core.dll nunit.core.interfaces.dll nunit.framework.dll nunit.mocks.dll nunit.util.dll ; do
    gacutil -i %{buildroot}%{_monodir}/nunit2/$i -package nunit2 -root %{buildroot}%{_monodir}/../
done
desktop-file-install --dir=%{buildroot}/%{_datadir}/applications %{SOURCE4}
cp -p src/GuiRunner/nunit-gui-exe/App.ico %{buildroot}/%{_datadir}/icons/NUnit2/nunit.ico

Comment 4 Timotheus Pokorra 2016-08-17 08:04:42 UTC
I have fixed the install -p in those 2 lines, sorry I missed them earlier.
The rest of the lines stayed the same, right?
Or what is wrong about them?

Spec URL: https://tpokorra.fedorapeople.org/nunit2/nunit2.spec
SRPM URL: https://tpokorra.fedorapeople.org/nunit2/nunit2-2.6.4-13.fc26.src.rpm

Comment 5 gil cattaneo 2016-08-17 14:07:33 UTC
(In reply to Timotheus Pokorra from comment #4)
> I have fixed the install -p in those 2 lines, sorry I missed them earlier.
> The rest of the lines stayed the same, right?
> Or what is wrong about them?
cp -p src/GuiRunner/nunit-gui-exe/App.ico %{buildroot}/%{_datadir}/icons/NUnit2/nunit.ico
to preserve timestamp

Comment 6 gil cattaneo 2016-08-17 14:08:56 UTC
have time for this https://bugzilla.redhat.com/show_bug.cgi?id=1366835 ?

Comment 7 Claudio Rodrigo Pereyra DIaz 2016-08-17 14:42:21 UTC
Need verify this points

[ ]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/mono/nunit2
[ ]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/mono/nunit2
[ ]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/mono/gac/nunit-
     console-runner(nunit),
     /usr/lib/mono/gac/nunit.mocks/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.framework(nunit),
     /usr/lib/mono/gac/nunit.util(nunit),
     /usr/lib/mono/gac/nunit.framework/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.mocks(nunit),
     /usr/lib/mono/gac/nunit.util/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core.interfaces/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core.interfaces(nunit),
     /usr/lib/mono/gac/nunit.core/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit-console-
     runner/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core(nunit)
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     nunit2-doc

Comment 8 Timotheus Pokorra 2016-08-22 06:27:49 UTC
I have fixed the cp -p, and the ownership for /usr/lib/mono/nunit2, and the requires name and isa.

I think I cannot do something for ownership for /usr/lib/mono/gac. Or is there a way?

Regarding the review of other packages: I am not a detailer in that regard, if it works I am happy, but that does not always meet the requirements of a package in Fedora...

Comment 9 Claudio Rodrigo Pereyra DIaz 2016-08-25 10:49:43 UTC
Look good for me.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 1051 files have unknown license.
     Detailed output of licensecheck in
     /data/fedora/1366713-nunit2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/mono/gac/nunit-
     console-runner(nunit),
     /usr/lib/mono/gac/nunit.mocks/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.framework(nunit),
     /usr/lib/mono/gac/nunit.util(nunit),
     /usr/lib/mono/gac/nunit.framework/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.mocks(nunit),
     /usr/lib/mono/gac/nunit.util/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core.interfaces/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core.interfaces(nunit),
     /usr/lib/mono/gac/nunit.core/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit-console-
     runner/2.6.4.0__96d09a1eb7f44a77(nunit),
     /usr/lib/mono/gac/nunit.core(nunit)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in nunit2-gui
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in nunit2-gui
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 3092480 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nunit2-2.6.4-13.fc24.x86_64.rpm
          nunit2-gui-2.6.4-13.fc24.x86_64.rpm
          nunit2-doc-2.6.4-13.fc24.x86_64.rpm
          nunit2-devel-2.6.4-13.fc24.x86_64.rpm
          nunit2-2.6.4-13.fc24.src.rpm
nunit2.x86_64: W: spelling-error %description -l en_US NUnit -> N Unit, Unit, Nu nit
nunit2.x86_64: E: no-binary
nunit2.x86_64: W: only-non-binary-in-usr-lib
nunit2.x86_64: W: no-documentation
nunit2.x86_64: W: no-manual-page-for-binary nunit-console26
nunit2-gui.x86_64: W: only-non-binary-in-usr-lib
nunit2-gui.x86_64: W: no-documentation
nunit2-gui.x86_64: W: no-manual-page-for-binary nunit-gui26
nunit2-devel.x86_64: W: only-non-binary-in-usr-lib
nunit2-devel.x86_64: W: no-documentation
nunit2.src: W: spelling-error %description -l en_US NUnit -> N Unit, Unit, Nu nit
5 packages and 0 specfiles checked; 1 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nunit2.x86_64: W: spelling-error %description -l en_US NUnit -> N Unit, Unit, Nu nit
nunit2.x86_64: E: no-binary
nunit2.x86_64: W: only-non-binary-in-usr-lib
nunit2.x86_64: W: no-documentation
nunit2.x86_64: W: no-manual-page-for-binary nunit-console26
nunit2-gui.x86_64: W: only-non-binary-in-usr-lib
nunit2-gui.x86_64: W: no-documentation
nunit2-gui.x86_64: W: no-manual-page-for-binary nunit-gui26
nunit2-devel.x86_64: W: only-non-binary-in-usr-lib
nunit2-devel.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 1 errors, 9 warnings.



Requires
--------
nunit2 (rpmlib, GLIBC filtered):
    /bin/sh
    mono(System)
    mono(System.Configuration)
    mono(System.Drawing)
    mono(System.Runtime.Remoting)
    mono(System.Windows.Forms)
    mono(System.Xml)
    mono(mscorlib)
    mono(nunit-console-runner)
    mono(nunit.core)
    mono(nunit.core.interfaces)
    mono(nunit.framework)
    mono(nunit.uiexception)
    mono(nunit.uikit)
    mono(nunit.util)

nunit2-gui (rpmlib, GLIBC filtered):
    /bin/sh
    mono(mscorlib)
    mono(nunit-gui-runner)
    nunit2(x86-64)

nunit2-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    nunit2(x86-64)
    pkgconfig

nunit2-doc (rpmlib, GLIBC filtered):
    nunit2(x86-64)



Provides
--------
nunit2:
    mono(nunit-console)
    mono(nunit-console-runner)
    mono(nunit-gui-runner)
    mono(nunit.core)
    mono(nunit.core.interfaces)
    mono(nunit.framework)
    mono(nunit.mocks)
    mono(nunit.uiexception)
    mono(nunit.uikit)
    mono(nunit.util)
    nunit2
    nunit2(x86-64)

nunit2-gui:
    application()
    application(nunit2.desktop)
    mimehandler(application/octet-stream)
    mono(nunit)
    nunit2-gui
    nunit2-gui(x86-64)

nunit2-devel:
    nunit2-devel
    nunit2-devel(x86-64)
    pkgconfig(nunit2)

nunit2-doc:
    nunit2-doc
    nunit2-doc(x86-64)



Source checksums
----------------
https://github.com/nunit/nunitv2/archive/2.6.4.tar.gz :
  CHECKSUM(SHA256) this package     : d5d3ed8d4f811b33f07ede67025dbcf1c4949e076130489a292002bee73e68b1
  CHECKSUM(SHA256) upstream package : d5d3ed8d4f811b33f07ede67025dbcf1c4949e076130489a292002bee73e68b1


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1366713
Buildroot used: fedora-24-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 10 gil cattaneo 2016-08-25 10:59:38 UTC
@ Claudio maybe you should set the fields: "Assigned to" and "Status"

Comment 11 Gwyn Ciesla 2016-08-26 13:28:58 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/nunit2

Comment 12 Raphael Groner 2016-08-28 16:34:45 UTC
Can you please try to also rebuild sharpziplib, restsharp and newtonsoft-json with the new nunit, I could give you commit rights to update the packages. All three packages fail in koschei due to the broken nunit dependency. Sorry, I do not have the time currently to do it by myself.

Comment 13 Timotheus Pokorra 2016-08-31 07:32:33 UTC
@Raphael, I have requested commit rights on those 3 packages.

Comment 14 Raphael Groner 2016-08-31 18:09:21 UTC
Approved all three packages and readded newtonsoft-json to Koschei. Please don't add restsharp and sharpziplib to Koschei, currently there's no package that uses both, so we don't need integration testing. Please correct me if I'm wrong.

Comment 15 Timotheus Pokorra 2016-09-01 04:34:16 UTC
I have rebuilt all three packages for rawhide: newtonsoft-json, restsharp and sharpziplib, using nunit2 instead of nunit.

I think there will be a mass rebuild for Fedora 26, since there has not been one for Fedora 25. So we should catch any other packages that want NUnit 2 but are using the nunit package. Of course, if we fix them earlier, the better.

Comment 16 Raphael Groner 2016-09-01 19:19:00 UTC
Please be also aware about bug #1354599.

Comment 17 Raphael Groner 2016-10-02 20:00:17 UTC
Can we close here? Packages are available as of now in Rawhide and EPEL7. Maybe you can also build a package for F25, as you requested the branch.

Comment 18 Timotheus Pokorra 2016-10-03 06:56:41 UTC
I think there is not much benefit of upgrading the nunit package in Fedora 25 to NUnit3. There is no nunit gui stable yet, and no package requires nunit3 in Fedora 25.
Therefore there is no need for nunit2 for compatibility reasons.
I will drop the F25 branch for nunit2.

Comment 19 Timotheus Pokorra 2016-10-03 06:59:50 UTC
hmm, dropping the Fedora 25 branch would mean orphaning and retiring? I will just keep it for the moment. Perhaps after the release of Fedora 25 we decide to upgrade MonoDevelop for some reason, and then it will be good to have that branch already available.

Comment 20 Raphael Groner 2016-10-03 08:51:55 UTC
(In reply to Timotheus Pokorra from comment #18)
> I think there is not much benefit of upgrading the nunit package in Fedora
> 25 to NUnit3. There is no nunit gui stable yet, and no package requires
> nunit3 in Fedora 25.
> Therefore there is no need for nunit2 for compatibility reasons.
> I will drop the F25 branch for nunit2.

No. https://bugzilla.redhat.com/show_bug.cgi?id=1270525#c10


Note You need to log in before you can comment on or make changes to this bug.